////////////////////////////////////////////////////////////////////////////////
// Main Class File:  CounterApp.java
// File:             Counter.java
// Semester:         Spring 2008
//
// Author:           Tim Bahls
// CS Login:         bahls
// Lecturer:         Tim Bahls
////////////////////////////////////////////////////////////////////////////////

/**
 * A simple class for counting things
 * 
 * @author Tim Bahls
 */
public class Counter {

	// The number we have counted to so far
	private int count;

	/**
	 * This constructor creates and returns a default counter that starts at
	 * zero.
	 * 
	 */
	public Counter() {
		this.count = 0;
	}

	/**
	 * This constructor creates and returns a counter that starts at the
	 * specified time.
	 * 
	 * @param startCount
	 *            The number at which the counter starts
	 */
	public Counter(int startCount) {
		this.count = startCount;
	}

	/**
	 * Increase the current count by one.
	 * 
	 */
	public void increment() {
		this.count = this.count + 1;
	}

	/**
	 * Start the count over at zero
	 * 
	 */
	public void reset() {
		count = 0;
	}

	/**
	 * Returns the current count of this counter.
	 * 
	 * @return The current count
	 */
	public int getCount() {
		return count;
	}

	/**
	 * Creates a brand new Counter that has the same counter as this Counter.
	 * 
	 * @return A new Counter that starts at getCount()
	 */
	public Counter createEquivalentCounter() {
		return new Counter(this.count);
	}
}
